;***************************************************************************
;
; File Name		:'timer0_m48_CTC.asm"
; Title			:Timer0 setup on Atmega48 in CTC mode
; Date			:2005.10.10.
; Version		:1.0.0
; Support telephone	:+36-70-333-4034, Old: +36-30-9541-658
; Support fax		:
; Support Email		:info@vfx.hu
; Target MCU		:ATmega48
;
;***************************************************************************
;	D E S C R I P T I O N
;
;
;***************************************************************************
;	M O D I F I C A T I O N   H I S T O R Y
;
;
;       rev.      date      who  	why
;	----	----------  ---		--------------------------------------------
;	0.01	2005.10.10  VFX		Creation
;
;
;***************************************************************************
;Hardware


;***************************************************************************
;* Const Def



;**************************************************************************
;* Hardware Def.
;


;***************************************************************************
;**** VARIABLES
.DSEG


;***************************************************************************
.ESEG

;***************************************************************************
;****		I N T E R R U P T S
;****
;***************************************************************************
.CSEG


;************************************************************************
;************************************************************************
;
Timer0_Init:

		lds	R16,PRR
		andi	R16,255-(1<<PRTIM0)	;Timer0 wake up
		sts	PRR,R16

		clr	R16
		out	TCNT0,R16		;Timer0=0

		ldi	R16,156			;~50Hz Interrupt @8MHz
		out	OCR0A,R16

		lds	R16,TIMSK0
		andi	R16,0b11111000
		ori	R16,0b00000010
		sts	TIMSK0,R16		;Interrupt CompA

		ldi	R16,0b00000010
		out	TCCR0A,R16		;COM0A1 COM0A0 COM0B1 COM0B0 - - WGM01 WGM00

		ldi	R16,0b00000101		;FOC0A FOC0B - - WGM02 CS02 CS01 CS00
		out	TCCR0B,R16		;Start PWM

		ret


;*******************************************************************
; Timer0 Stop and Shutdown
;
Timer0_Shutdown:
		ldi	R16,0b00000000		;FOC0A FOC0B - - WGM02 CS02 CS01 CS00
		out	TCCR0B,R16		;Stop PWM

		lds	R16,PRR
		ori	R16,(1<<PRTIM0)		;Timer0 sleep
		sts	PRR,R16

		ret

;*******************************************************************
; Timer0 CompareA Handler
;
TIM0_COMPA:
		push	ZL
		push	ZH
		in	ZL,SREG			;preserve main OS status reg.
		push	ZL

	     	lds	ZL,SCNT2+0 		;Software Timer2/XMODEM
		lds	ZH,SCNT2+1
		OR	ZL,ZH
		BREQ	Tmr0_Exit
		lds	ZL,SCNT2+0
		SBIW	ZL,1
		sts	SCNT2+0,ZL
		sts	SCNT2+1,ZH

Tmr0_Exit:
		pop	ZL
		out	SREG,ZL			; restore previous status reg
		pop	ZH
		pop	ZL
		RETI


